/* blink2.c */

#include "olimex-sam9L9260.h"

void write_pio(unsigned long *address, unsigned long value);
void delay();


void c_entry()  /* main() */
{
  AT91PS_PIO base_address = (AT91PS_PIO)	PIOA_BASE_ADDRESS;
  
  /* Set the PIO controller in PIO mode instead of peripheral mode */
  write_pio((unsigned long *)&(base_address->PIO_PER), (LED_A | LED_B));
  
  /* Configure the pin in output */
  write_pio((unsigned long *)&(base_address->PIO_OER), (LED_A | LED_B));

  /* Disable pull-up resitors */
  write_pio((unsigned long *)&(base_address->PIO_PPUDR), (LED_A | LED_B));

  while(1) {
    write_pio((unsigned long *)&(base_address->PIO_CODR), LED_A);
    write_pio((unsigned long *)&(base_address->PIO_CODR), LED_B);
    delay();
    write_pio((unsigned long *)&(base_address->PIO_SODR), LED_A);
    write_pio((unsigned long *)&(base_address->PIO_SODR), LED_B);
    delay();
  }

}

void write_pio(unsigned long *address, unsigned long value)
{
  *address = value;
}

void delay()
{
  int i, j;
  for(i=0; i < 100000; i++) j += i;
}
